var motor1_ist int
var motor1_soll int
var motor2_ist int
var motor2_soll int
var motor3_ist int
var motor3_soll int
var motor4_ist int
var motor4_soll int
var motor1_dir byte
var motor2_dir byte
var motor3_dir byte
var motor4_dir byte
var record byte

dim array (100,4) int
var index byte
var pindex byte
var a byte
var speed_hi byte
var speed_lo byte

function referenz (a byte,b byte)						// Fhrt die jeweilige Achse auf Referenzposition
  motor a,speed_lo                                                                                                     // Geschwindigkeit 2
  ref_wait:
  if input(b) = 0											// Referenzposition erreicht?
    goto ref_wait												// falls nein, dann warten
  end
  motor a,0													// Motor stoppen
return

function pos (a byte,b byte,ist int,soll int)	// Fhrt die jeweilige Achse auf Position
  if soll > ist												// Zunchst die Richtung festlegen
    motor a,-speed_hi                                                                                          // Mit voller Leistung fahren
    ploop1:
    if soll < (ist + 10)        						// Wenn nur noch 10 Impulse zur Zielpos. fehlen, reduzieren
      motor a,-speed_lo
    end
    edge any b												// auf eine Flanke des Impulstasters warten
    ist = ist + 1												// Zhlvariable hochzhlen
    if soll > ist												// solange wiederholen, bis Pos. erreicht
      goto ploop1
    end
  else
    motor a,speed_hi                                                                                                   // s.o., fr die andere Richtung
    ploop2:
    if soll > (ist - 10)
      motor a,speed_lo
    end
    edge any b
    ist = ist - 1
    if soll < ist
      goto ploop2
    end
  end
  motor a,0													// Wenn Pos. erreicht, Motor abschalten
return

// Diese Subroutine fhrt die Positionen auf allen vier Achsen gleichzeitig
// an und wartet solange, bis alle Achsen die Zielposition erreicht haben

function position_ (pos1 int,pos2 int,pos3 int,pos4 int)

motor1_soll = pos1
motor2_soll = pos2
motor3_soll = pos3
motor4_soll = pos4

pos_wait:														// In dieser Schleife wird solange gewartet, bis alle 
																	// Achsen die Soll-Pos. erreicht haben
 if motor1_ist <> motor1_soll
   goto pos_wait
 end

 if motor2_ist <> motor2_soll
   goto pos_wait
 end

 if motor3_ist <> motor3_soll
   goto pos_wait
 end

 if motor4_ist <> motor4_soll
   goto pos_wait
 end
return

task motor1														// Jede Achse hat ihren eigenen Task, so knnen die Achsen unabhngig 			
m1loop:															// voneinander verfahren werden.
	if record = 1
		edge any 2
		motor1_ist = motor1_ist + motor1_dir
	else

		if motor1_ist = motor1_soll								// Falls Soll = Ist, ist keine Bewegung notwendig.
			goto m1loop
		end

		if motor1_soll = 0											// Soll die Referenzposition angefahren werden?
			referenz (1,1)											// Falls ja, dann Motor 1 auf Referenz fahren, Eingang fr Ref.-Pos. ist 1
			motor1_ist = 0											// Wenn die Referenzpos. erreicht ist, die Ist-Pos. korrigieren
			goto m1loop
		end

		pos (1,2,motor1_ist,motor1_soll)						// ansonsten die Position anfahren
		motor1_ist = motor1_soll									// Wenn die Soll-Pos. erreicht ist, die Ist-Pos. korrigieren
	end
goto m1loop														// Schleife schlieen, damit der Task endlos ausgefhrt wird.
end

task motor2
m2loop:
	if record = 1
		edge any 4
		motor2_ist = motor2_ist + motor2_dir
	else

		if motor2_ist = motor2_soll
			goto m2loop
		end
		
		if motor2_soll = 0
			referenz (2,3)
			motor2_ist = 0
			goto m2loop
		end
		
		pos (2,4,motor2_ist,motor2_soll)
		motor2_ist = motor2_soll
	end
goto m2loop
end

task motor3
m3loop:
	if record = 1
		edge any 6
		motor3_ist = motor3_ist + motor3_dir
	else
		if motor3_ist = motor3_soll
			goto m3loop
		end
		
		if motor3_soll = 0
			referenz (3,5)
			motor3_ist = 0
			goto m3loop
		end
		
		pos (3,6,motor3_ist,motor3_soll)
		motor3_ist = motor3_soll
	end
goto m3loop
end

task motor4
m4loop:
	if record = 1
		edge any 8
		motor4_ist = motor4_ist + motor4_dir
	else
		if motor4_ist = motor4_soll
			goto m4loop
		end
	
		if motor4_soll = 0
			referenz (4,7)
			motor4_ist = 0
			goto m4loop
		end
	
		pos (4,8,motor4_ist,motor4_soll)
		motor4_ist = motor4_soll
	end
goto m4loop
end

main:
print 10
motor1_ist = 10								// Die Vorbelegung mit 10 ist notwendig, damit der Referenzpunkt 
motor1_soll = 10								// am Beginn des Programms angefahren werden kann.
motor2_ist = 10
motor2_soll = 10
motor3_ist = 10
motor3_soll = 10
motor4_ist = 10
motor4_soll = 10

index = 1
speed_hi = 6
speed_lo = 3

start motor1									// Die vier Tasks fr die Achsen starten
start motor2
start motor3
start motor4

print 1

position_(0,0,0,0)                                                      // Liste mit Positionen, die nacheinander angefahren werden. Zunchst Referenz

array (index,1) = 0
array (index,2) = 0
array (index,3) = 0
array (index,4) = 0

index = index + 1

record:

record = 1

mainloop:

select ir
case #m1l1
	motor1_dir = -1
	if input(1) = 0
		motor 1,speed_lo
	end
	wait1:
	if ir <> 0
		if input(1) = 1
			motor 1,0
			motor1_ist = 0
		end
		goto wait1
	end
	motor 1,0
case #m1r1
	motor1_dir = 1
	motor 1,-speed_lo
	wait2:
	if ir <> 0
		if motor1_ist > 300
		  motor 1,0
		end
		goto wait2
	end
	motor 1,0
case #m2l1
	motor2_dir = -1
	if input(3) = 0
		motor 2,speed_lo
	end
	wait3:
	if ir <> 0
		if input(3) = 1
			motor 2,0
			motor2_ist = 0
		end
		goto wait3
	end
	motor 2,0
case #m2r1
	motor2_dir = 1
	motor 2,-speed_lo
	wait4:
	if ir <> 0
		if motor2_ist > 160
			motor 2,0
		end
		goto wait4
	end
	motor 2,0
case #m3l1
	motor3_dir = -1
	if input(5) = 0
		motor 3,speed_lo
	end
	wait5:
	if ir <> 0
		if input(5) = 1
			motor 3,0
			motor3_ist = 0
		end
		goto wait5
	end
	motor 3,0
case #m3r1
	motor3_dir = 1
	motor 3,-speed_lo
	wait6:
	if ir <> 0
		if motor3_ist > 114
			motor 3,0
		end
		goto wait6
	end
	motor 3,0
case #m1spd1
	motor4_dir = -1
	if input(7) = 0
		motor 4,speed_lo
	end
	wait7:
	if ir <> 0
		if input(7) = 1
			motor 4,0
			motor4_ist = 0
		end
		goto wait7
	end
	motor 4,0
case #m2spd1
	motor4_dir = 1
	motor 4,-speed_lo
	wait8:
	if ir <> 0
		if motor4_ist > 25
			motor 4,0
		end
		goto wait8
	end
	motor 4,0
case #m3spd1
	array (index,1) = motor1_ist
	array (index,2) = motor2_ist
	array (index,3) = motor3_ist
	array (index,4) = motor4_ist
   print index
	print motor1_ist
	print motor2_ist
	print motor3_ist
	print motor4_ist
	print 9999
	index = index + 1
	wait9:
	if ir <> 0
		goto wait9
	end
end

if ir = #code1
	record = 0
	goto play
end

//position_(motor1_pos,motor2_pos,motor3_pos,motor4_pos)

goto mainloop

play:

kill motor1
start motor1
kill motor2
start motor2
kill motor3
start motor3
kill motor4
start motor4

print record
position_(0,0,0,0)
print 20

speed_hi = 8
speed_lo = 5

for pindex = 1 to (index-1)
        position_ (array(pindex,1),array(pindex,2),array(pindex,3),array(pindex,4))
        print pindex
        print array(pindex,1)
        print array(pindex,2)
        print array(pindex,3)
        print array(pindex,4)
        print 9999
next

speed_hi = 6
speed_lo = 3

print 30
goto record

